package nl.amis.demo.view.backingbeans;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

import javax.faces.context.FacesContext;
import javax.faces.event.ActionEvent;

import javax.faces.event.ValueChangeEvent;

import javax.servlet.http.HttpServletRequest;

import nl.amis.demo.dynacols.model.revenue.types.RevenueData;

import nl.amis.demo.view.type.ColumnHeader;

import oracle.adf.model.BindingContext;
import oracle.adf.model.OperationBinding;
import oracle.adf.model.binding.DCBindingContainer;
import oracle.adf.model.binding.DCUtil;
import oracle.adf.view.faces.component.core.data.CoreTable;
import oracle.adf.view.faces.context.AdfFacesContext;

public class RevenueOverViewBB {


    private List<RevenueData> revenueData;

    private Object year;
    private Object maxYear;
    private Object minYear;

    private String deptId;


    private ArrayList<ColumnHeader> columnHeaders = 
        new ArrayList<ColumnHeader>();

    private int numberOfHeadersToAdd = 0;
    private int numberOfColsToAdd = 0;
    private CoreTable revenueDataTable;

    public RevenueOverViewBB() {
    }

    public void getRevenue(ActionEvent actionEvent) {
        // Add event code here...

        // init
        setNumberOfColsToAdd(0);
        // kolomheaders leegmaken
        columnHeaders.clear();
        // faseringen leegmaken.
        setRevenueData(null);

        DCBindingContainer bindings = getCurrentBindingContainer();
        OperationBinding operationBinding = 
            (OperationBinding)bindings.getOperationBinding("getRevenue");

        operationBinding.getParamsMap().put("deptId", this.deptId); //
        operationBinding.getParamsMap().put("year", this.year); //

        setRevenueData((List<RevenueData>)operationBinding.execute());

        if (revenueData.get(0).getPeriodData().size() > 0) {
            setNumberOfColsToAdd(revenueData.get(0).getPeriodData().size() - 
                                 1);
        }

        RevenueData _RevenueDataLine = new RevenueData();

        Iterator readLines = revenueData.iterator();
        _RevenueDataLine = (RevenueData)readLines.next();

        // create columnHeaders: We need to do this here because we cannot use the var of the table component in the header facet in the way we need it.
        // also set the min and max year for the begroting.

        for (int i = 0; i < _RevenueDataLine.getPeriodData().size(); i++) {

            String _year = 
                _RevenueDataLine.getPeriodData().get(i).getPeriodName();
            ColumnHeader testHeader = new ColumnHeader();
            testHeader.setValue(_year);
            columnHeaders.add(testHeader);

            if (i == 0 && this.year == null) {
                setMinYear(_year);
            }

            if ((i + 1) == _RevenueDataLine.getPeriodData().size() && 
                this.year == null) {
                setMaxYear(_year);
            }

        }


        // now make sure to refresh the table!
        //        if (isDialogVisible()) {
        AdfFacesContext.getCurrentInstance().addPartialTarget(this.revenueDataTable);
        //        }


    }

    private DCBindingContainer getCurrentBindingContainer() {
        FacesContext ctx = FacesContext.getCurrentInstance();
        HttpServletRequest request = 
            (HttpServletRequest)ctx.getExternalContext().getRequest();
        BindingContext bcx = DCUtil.getBindingContext(request);
        DCBindingContainer container = null;
        if (bcx != null) {
            container = 
                    bcx.findBindingContainerByPath(ctx.getViewRoot().getViewId());
        }
        return container;
    }

    public void setRevenueData(List<RevenueData> revenueData) {
        this.revenueData = revenueData;
    }

    public List<RevenueData> getRevenueData() {
        return revenueData;
    }

    public void setYear(Object year) {
        this.year = year;
    }

    public Object getYear() {
        return year;
    }

    public void setDeptId(String deptId) {
        this.deptId = deptId;
    }

    public String getDeptId() {
        return deptId;
    }

    public void setNumberOfColsToAdd(int numberOfColsToAdd) {
        this.numberOfColsToAdd = numberOfColsToAdd;
    }

    public int getNumberOfColsToAdd() {
        return numberOfColsToAdd;
    }

    public void setMaxYear(Object maxYear) {
        this.maxYear = maxYear;
    }

    public Object getMaxYear() {
        return maxYear;
    }

    public void setMinYear(Object minYear) {
        this.minYear = minYear;
    }

    public Object getMinYear() {
        return minYear;
    }

    public void setRevenueDataTable(CoreTable revenueDataTable) {
        this.revenueDataTable = revenueDataTable;
    }

    public CoreTable getRevenueDataTable() {
        return revenueDataTable;
    }

    public void cellContentChanged(ValueChangeEvent valueChangeEvent) {
        // Add event code here...
    }

    public void setColumnHeaders(ArrayList<ColumnHeader> columnHeaders) {
        this.columnHeaders = columnHeaders;
    }

    public ArrayList<ColumnHeader> getColumnHeaders() {
        return columnHeaders;
    }
}
